<template>
  <div
    :style="{height: width + 'px', width: width + 'px'}">
    <svg viewBox="0 0 100 100">
      <path
        :d="trackPath"
        fill="none"
        stroke-width="4"
        :transform="'translate(2, -10)'"
        stroke="#01b5be"></path>
      <path
        :d="trackPath"
        fill="none"
        stroke="#192333"
        stroke-width="6"
        :transform="'translate(2, -10)'"
        :style="circlePathStyle"></path>
      <line
        :x1="lineXStart"
        :y1="lineYStart"
        :x2="lineXStart"
        :y2="radius + offsets.arrow"
        stroke-width="4"
        :transform="'translate(2, -10)'"
        stroke="#01b5be"></line>
      <line
        :x1="lineXStart"
        :y1="lineYStart"
        :x2="normalizedMinutePos.x"
        :y2="normalizedMinutePos.y"
        stroke-width="4"
        :transform="'translate(2, -10)'"
        stroke="#01b5be"></line>
    </svg>
  </div>
</template>

<script>


  export default {
    name: "TheClock",
    props: {
      width: {
        type: Number,
        default: 126
      },
      progress: {
        type: Number,
        default: 0
      }
    },
    data() {
      return {
        offsets: {
          x: 50,
          y: 0,
          arrow: 5
        },
        radius: 30,
      }
    },
    computed: {
      lineXStart() {
        return this.offsets.x;
      },
      lineYStart() {
        return this.offsets.y + this.radius * 2;
      },
      perimeter() {
        return 2 * Math.PI * this.radius;
      },
      trackPath() {
        return `
          M ${this.offsets.x} ${this.offsets.y}
          m 0 ${this.radius}
          a ${this.radius} ${this.radius} 0 1 1 0 ${this.radius * 2}
          a ${this.radius} ${this.radius} 0 1 1 0 -${this.radius * 2}
        `;
      },
      circlePathStyle() {
        return {
          strokeDasharray: `${this.perimeter * (this.progress / 100) }px, ${this.perimeter}px`,
          strokeDashoffset: 0,
          transition: 'stroke-dasharray 0.6s ease 0s, stroke 0.6s ease'
        };
      },
      clockMinuteLinePos() {
        const angle = 360 / 100 * this.progress;
        const angleRad = (angle) * Math.PI / 180;
        const x = (this.radius * Math.sin(angleRad) + this.offsets.x);
        const y = (-this.radius * Math.cos(angleRad) + this.radius * 2);
        return {x, y};
      },
      normalizedMinutePos() {
        const pos = this.clockMinuteLinePos;
        const sqrtPos = Math.sqrt(Math.pow(pos.x - this.lineXStart, 2) + Math.pow(pos.y - this.lineYStart, 2));
        const v0 = {
          x: (pos.x - this.lineXStart) / sqrtPos * this.offsets.arrow,
          y: (pos.y - this.lineYStart) / sqrtPos * this.offsets.arrow
        };
        return {
          x: pos.x - v0.x,
          y: pos.y - v0.y
        }
      }
    }
  }
</script>
